#include "postgres.h"
#include "executor/executor.h"
#include "fmgr.h"
#include "funcapi.h"

PG_MODULE_MAGIC;

extern void _PG_init(void);

// hook for executor 
extern ExecutorStart_hook_type ExecutorStart_hook;

static void my_ExecutorStart(QueryDesc *queryDesc, int eflags);

// Called when this module is loaded at the first time.
void _PG_init(void) {
    ExecutorStart_hook = my_ExecutorStart;
}

// Executor hook
static void my_ExecutorStart(QueryDesc *queryDesc, int eflags) {
    elog(INFO, "Hello \\ (^ o ^) /");
    standard_ExecutorStart(queryDesc, eflags);
}

/*
 * Original Function myext
 */
PG_FUNCTION_INFO_V1(myext);

/**
 *  myext is only a function which returns true.
 */
Datum                                   
myext(PG_FUNCTION_ARGS) 
{
    PG_RETURN_BOOL(true);                                   
}
